<template>
  <div>
    <v-row>
      <v-col cols="12">
        <h1>action api</h1>
        <v-btn class="mt-3" color="success" @click="getData()">get data</v-btn>
        <v-btn color="primary" @click="newItem()">สร้างข้อมูล</v-btn>
      </v-col>
    </v-row>
    <v-row>
      <v-col v-for="(item, index) in apidata" :key="index" cols="3">
        <v-card width="350px">
          <v-img
            src="https://i1.sndcdn.com/artworks-000191633248-ye4tjs-t500x500.jpg"
          ></v-img>
          <!-- v-if="item.firstName === 'Cristaino'" -->
          <v-card-title primary-title
            >Name: {{ item.firstName }} <br />
            LastName: {{ item.lastName }} <br />
            age: {{ item.age }}</v-card-title
          >
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="info" text @click="editItem(item)">edit</v-btn>
            <v-btn color="error" @click="saveDelete(item._id)">delete</v-btn>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>

    <!-- Dialog for Editing Data -->
    <v-dialog v-model="dialogedit" max-width="500px">
      <v-card>
        <v-card-title>{{ savemode }}</v-card-title>
        <v-row>
          <v-col cols="6">
            <v-text-field
              v-model="postdata.username"
              label="Username"
              type="string"
              id="id"
            ></v-text-field>
          </v-col>
          <v-col cols="6">
            <v-text-field
              v-model="postdata.password"
              label="password"
              id="password"
            ></v-text-field>
          </v-col>
          <v-col cols="6">
            <v-text-field
              v-model="postdata.firstName"
              label="firstName"
              id="firstName"
            ></v-text-field>
          </v-col>
          <v-col cols="6">
            <v-text-field
              v-model="postdata.lastName"
              label="lastname"
              id="id"
            ></v-text-field>
          </v-col>
          <v-col cols="6">
            <v-text-field
              v-model.number="postdata.use_id"
              label="user_id"
              id="id"
            ></v-text-field>
          </v-col>
          <v-col cols="6">
            <v-text-field
              v-model.number="postdata.age"
              label="age"
              id="age"
            ></v-text-field>
          </v-col>
          <v-col cols="6">
            <v-text-field
              v-model="postdata.gender"
              label="gender"
              id="gender"
            ></v-text-field>
          </v-col>
        </v-row>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="error" text @click="closeItem()">cancel</v-btn>
          <v-btn color="info" text @click="saveSelect()">save</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
export default {
  data() {
    return {
      id: "",
      dialogedit: false,
      postdata: {
        use_id: 0,
        username: "",
        password: "",
        firstName: "",
        lastName: "",
        age: 0,
        gender: "",
      },
      postdefault: {
        use_id: 0,
        username: "",
        password: "",
        firstName: "",
        lastName: "",
        age: 0,
        gender: "",
      },
      apidata: [],
    };
  },
  created() {
    this.getData();
  },
  computed: {
    savemode() {
      return this.id == "" ? "NeWItem" : "Edit Item";
    },
  },
  methods: {
    newItem() {
      this.id = "";
      this.postdata = { ...this.postdefault };
      this.dialogedit = true;
    },
    editItem(item) {
      console.log(item);
      this.id = item._id;
      this.postdata = item;
      this.dialogedit = true;
    },
    closeItem() {
      this.id = "";
      this.postdata = { ...this.postdefault };
      this.dialogedit = false;
    },
    saveSelect() {
      if (this.id != "") {
        this.savePutData();
      } else {
        this.savePostData();
      }
    },
    async savePostData() {
      try {
        const { data } = await this.axios.post(
          "http://localhost:3000/listUser/",
          this.postdata
        ); //this.potdata เป็น body
        console.log(data);
        alert("Create Data Complete");
        this.getData();
        this.closeItem();
      } catch (error) {
        console.log(error);
        alert(error);
      }
    },
    async savePutData() {
      try {
        const { data } = await this.axios.put(
          "http://localhost:3000/listUser/" + this.id,
          this.postdata
        ); //this.potdata เป็น body
        alert("Update Data Complete");
        console.log(data);
        this.getData();
        this.closeItem();
      } catch (error) {
        console.log(error);
        alert(error);
      }
    },
    async saveDelete(item) {
      try {
        if (confirm("delete it?")) {
          const { data } = await this.axios.delete(
            "http://localhost:3000/listUser/" + item
          );
          console.log(data);
          this.getData();
          this.closeItem();
        }
      } catch (error) {
        console(error);
        alert(error);
      }
    },

    getData() {
      this.axios.get("http://localhost:3000/listUser/").then((response) => {
        console.log(response.data.data);
        this.apidata = response.data.data;
      });
    },
  },
};
</script>

<style></style>
